# Copyright 2021-2022 Huawei Technologies Co., Ltd
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
# ============================================================================

import os
import os.path
import re
import sys

import yaml


def check_true_path(model_dir):
    try:
        model_dir = os.path.realpath(model_dir)
    except ValueError:
        # Logger.ser.exception(ex)
        sys.exit(1)
    finally:
        pass

    trust_path = re.match(r'[a-zA-Z0-9.\:\/\\\_\-]*Horizontal_FL', model_dir)

    if trust_path:
        true_path_flag = True
        return true_path_flag
    else:
        e = ValueError("Input Path is not Trust or not permits !")
        # Logger.ser.exception(e)
        raise e


def load_config(file_name):
    """check config file path whether truth"""
    check_true_path(file_name)

    with open(file_name, 'r', encoding='utf-8') as file:
        try:
            config = yaml.safe_load(file)
            return config
        except yaml.YAMLError as exc:
            sys.exit(1)
        finally:
            pass
